=== debian/changelog ===
hipsparse (5.7.1-1build2) resolute; urgency=medium

  * No change rebuild against new rocm-hipamd.

 -- Mario Limonciello <superm1@gmail.com>  Mon, 27 Oct 2025 12:54:32 -0500

hipsparse (5.7.1-1build1) oracular; urgency=medium

  * Rebuild against new rocm-hipamd/arm64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 03 Aug 2024 09:01:35 +0200

hipsparse (5.7.1-1) unstable; urgency=medium

  [ Christian Kastner ]
  * Update upstream URL

  [ Cordell Bloor ]
  * Migrate to unstable
  * d/control: drop hipcc to from Build-Depends
  * d/control: add rocm-device-libs-17 to Build-Depends
  * d/rules: reenable dwz and use uncompressed debug symbols
  * d/control: dev package now suggests doc package

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 29 Mar 2024 16:35:39 -0600

hipsparse (5.7.1-1~exp1) experimental; urgency=medium

  * New upstream version.
    - Refresh patches
    - Refresh documentation build step
  * dbgsym: Disable dwz and switch to compressed DWARF-5
  * Add support for the 'nocheck' build profile
  * Add debian/clean (Closes: #1049079)
  * Add myself to Uploaders
  * autopkgtest: Export dmesg and other info as artifacts
  * Bump copyrights

 -- Christian Kastner <ckk@debian.org>  Sun, 25 Feb 2024 20:11:50 +0100
