=== debian/control ===
Source: hipsparse
Section: devel
Homepage: https://github.com/ROCm/hipsparse
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rocm-team/hipsparse.git
Vcs-Browser: https://salsa.debian.org/rocm-team/hipsparse
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Cordell Bloor <cgmb@slerp.xyz>,
           Christian Kastner <ckk@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               rocm-cmake (>= 5.3.0),
               gfortran,
               rocm-device-libs-17,
               libamd-comgr-dev,
               libhsa-runtime-dev,
               libamdhip64-dev (>= 5.7.1~),
               librocsparse-dev,
               libgtest-dev <!nocheck>
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
               doxygen <!nodoc>,
               python3-breathe <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-sphinx-rtd-theme <!nodoc>,
               libjs-jquery <!nodoc>,
               libjs-mathjax <!nodoc>,
               libjs-sphinxdoc <!nodoc>,
               libjs-underscore <!nodoc>
Rules-Requires-Root: no

Package: libhipsparse0
Section: libs
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: portable interface for sparse linear algebra on the GPU - library
 hipSPARSE is a wrapper library that provides a common interface to rocSPARSE
 and cuSPARSE. The hipSPARSE library is designed to help applications using
 cuSPARSE to port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipSPARSE library.

Package: libhipsparse-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: libhipsparse0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends},
         libamdhip64-dev
Suggests: libhipsparse-doc
Description: portable interface for sparse linear algebra on the GPU - headers
 hipSPARSE is a wrapper library that provides a common interface to rocSPARSE
 and cuSPARSE. The hipSPARSE library is designed to help applications using
 cuSPARSE to port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipSPARSE development headers.

Package: libhipsparse0-tests
Section: libdevel
Build-Profiles: <!nocheck>
Architecture: amd64 arm64 ppc64el
Depends: libhipsparse0 (= ${binary:Version}),${misc:Depends}, ${shlibs:Depends},
Description: portable interface for sparse linear algebra on the GPU - tests
 hipSPARSE is a wrapper library that provides a common interface to rocSPARSE
 and cuSPARSE. The hipSPARSE library is designed to help applications using
 cuSPARSE to port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipSPARSE test binaries used for verifying
 that the library is functioning correctly. These binaries are only used to
 check whether hipSPARSE works correctly on a given GPU, so generally speaking,
 users probably don't need this package.

Package: libhipsparse-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
Description: portable interface for sparse linear algebra on the GPU - documentation
 hipSPARSE is a wrapper library that provides a common interface to rocSPARSE
 and cuSPARSE. The hipSPARSE library is designed to help applications using
 cuSPARSE to port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipSPARSE documentation.
