=== debian/tests/control ===
Test-Command: /bin/sh debian/tests/upstream-binaries libhipsparse0-tests
Depends: libhipsparse0-tests
Restrictions: skippable, allow-stderr, needs-sudo
Architecture: amd64 arm64 ppc64el
