## hipsparse 6.4.1

=== debian/changelog ===
hipsparse (6.4.1-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.1
    - Bumps SOVER libhipsparse0 -> libhipsparse1
  * Drop obsolete patches
  * Refresh patches
  * Bump dependency for rocsparse
  * Add Extend-docs-conf.py-for-offline-build.patch
  * Add Add-missing-GTest-includes-and-linking.patch
  * Add Skip-upstream-tests-requiring-upstream-binaries.patch
  * Build documentation with python3-rocm-docs
  * Switch test runner over to universal location
  * libhipsparse1.symbols: Add newly appeared symbols
  * d/rules: Drop -S, cmake is inferred
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Add patterns to d/clean
  * Update d/not-installed patterns
  * Update d/copyright
  * Add gbp.conf to reflect Team use

 -- Christian Kastner <ckk@debian.org>  Sun, 29 Jun 2025 22:19:31 +0200
